% !TEX encoding = UTF-8 Unicode

\documentclass[balance,upint,subscriptcorrection,varvw,mathalfa=cal=boondoxo,spanish,french,vietnamese,russian,greek,pdf-a,colorlinks]{asmeconf}

%%%%%  pdf metadata  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\hypersetup{%
	pdfauthor={Tomas Slimak},
	pdftitle={Overview of Design Considerations for Data-driven Time Stepping Schemes Applied to Non-linear Mechanical Systems},                
	pdfkeywords={ASME conference paper, LaTeX template, BibTeX style},
	pdfsubject = {Overview of Design Considerations for Data-driven Time Stepping Schemes Applied to Non-linear Mechanical Systems},			 
	pdflicenseurl={https://ctan.org/pkg/asmeconf},
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\usepackage{graphicx,import}
\usepackage{colortbl}
\usepackage[nolist]{acronym}
\usepackage{todonotes}



\begin{document}
	
	
	
	\begin{acronym}
		\acro{acf}[ACF]{absolute coordinate formulation}
		\acro{ACF}[ACF]{Absolute Coordinate Formulation}
		\acro{fe}[FE]{finite element}
		\acro{ffrf}[FFRF]{floating frame of reference formulation}
		\acro{gcms}[GCMS]{generalized component mode synthesis}
		\acro{GCMS}[GCMS]{Generalized Component Mode Synthesis}
		\acro{dofs}[DOFs]{degrees of freedom}
		\acro{dof}[DOF]{degree of freedom}
		\acro{eoms}[EOMs]{equations of motion}
		\acro{wrt}[w.r.t.]{with respect to}
		\acro{cms}[CMS]{component mode synthesis}
		\acro{dae}[DAE]{differential algebraic equation}
		\acro{mac}[MAC]{model assurance criterion}
		\acro{rbe3}[RBE3]{interpolation constraint element} 
		\acro{mpc}[MPC]{multi-point constraint} 
		\acro{mb}[MB]{multibody}   
		\acro{ancf}[ANCF]{absolute nodal coordinate formulation}  
		\acro{fncf}[FNCF]{flexible natural coordinate formulation}  
		\acro{rb}[RB]{rigid body} 
		\acro{nn}[NN]{neural network} 
		\acro{ml}[ML]{machine learning} 
		\acro{ff}[FF]{feedforward} 
		\acro{2d}[2D]{two dimensional} 
		\acro{gsd}[GSD]{granulometric size distribution} 
		
		
	\end{acronym}



% Change these fields to the right content for your conference.
% You can comment these out if for some reason you don't want a header.
% Use title case (first letters capitalized), not all capitals

\ConfName{Proceedings of the ASME 2023\linebreak International Design Engineering Technical Conferences and\linebreak Computers and Information in Engineering Conference}
\ConfAcronym{IDETC/CIE2023}
\ConfDate{August 20-23, 2023} % update 
\ConfCity{Boston, Massachusetts} % update 
\PaperNo{DETC2023-XXXXXX}

 

\title{Overview of Design Considerations for Data-driven Time Stepping Schemes Applied to Non-linear Mechanical Systems} 
\SetAuthors{%
	Tomas Slimak\affil{1}\CorrespondingAuthor{tomas.slimak@tum.de}, 
	Andreas Zwölfer\affil{1}, 
	Bojidar Todorov\affil{1},
	Daniel J. Rixen\affil{1}
	}

\SetAffiliation{1}{Chair of Applied Mechanics, Technical University of Munich}

\maketitle

\versionfootnote{Documentation for \texttt{asmeconf.cls}: Version~\versionno, \today.}

\keywords{Neural Network, Physics Informed, Multibody Dynamics, Nonlinear Dynamics, Machine Learning}


%%%%%  ABSTRACT  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% Abstract should be 200 words or less
\begin{abstract}
	
	Artificial \acp{nn} are a type of \ac{ml} algorithm that mimics the functioning of the human brain to learn and generalize patterns from large amounts of data without the need for explicit knowledge of the system's physics. 
	%
	Employing \acp{nn} to predict time responses in the field of mechanical system dynamics  is still in its infancy.
	%
	The aim of this contribution is to give an overview of design considerations for \ac{nn}-based time stepping schemes for  non-linear mechanical systems.
	%
	To this end numerous design parameters and choices available when creating a NN are presented and  their effects on the accuracy of predicting the dynamics of non-linear mechanical systems are discussed.
	%
	The findings are presented with the support of three test cases: a double pendulum, a duffing oscillator, and a  gyroscope. 
	%
	Factors such as initial conditions, external forcing as well as system parameters were varied to demonstrate the robustness of the proposed approaches. 
	%
	Furthermore, practical design considerations such as noise-sensitivity as well as the ability to extrapolate are examined.
	%
	Ultimately, we are able to show that \acp{nn} are capable of functioning as a time-stepping schemes for   non-linear mechanical system dynamics applications.
	
	
\end{abstract}

%%%%%%%%%  BODY OF PAPER %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Introduction}

\Ac{ml} has been used with growing popularity in various applications in engineering  as summarized in \cite{2020_Willard_ARXIV, 2020_Frank_COMP}.

Artificial \acp{nn} are a type of \ac{ml} algorithm that mimics the functioning of the human brain to learn and generalize patterns from large amounts of data without the need for explicit knowledge of the system's physics. 

\Acp{nn} are composed of layers of interconnected  neurons that receive input signals, which are weighted, combined, and biased -- weights and biases  are learned during training (backpropagation)   to minimize the error between the network's and  desired output  -- and then passed through a nonlinear activation function to produce an output signal. The output of one layer of neurons becomes the input   for the next layer, allowing for  complex nonlinear relationships between overall input  and output to be modeled, making them an attractive option for predicting the behavior of complex mechanical systems. 

Previous uses of \acp{nn} in the field of mechanics focused mainly on structural optimization, structural reliability analysis,  structural health monitoring,  material modeling, system identification, uncertainty quantification, and control design \cite{2022_Cunha_ARXIV,2020_Frank_COMP}.  

Surrogate modeling with \acp{nn}  in the field of mechanical system dynamics  is still less established  despite early investigations   \cite{1993_Masri_JAM} showing that   a multi-layer \ac{ff} \ac{nn} is able to predict nonlinear restoring forces of a linearly-damped duffing oscillator.

Similar studies  have been conducted more recently.  For example, \cite{2020_Roehrl_IFAC}  used a \ac{nn} which receives the states of a cart and its control  impulse as input  to predict the residual non-conservative forces representing unmodeled phenomena such as friction  of a cart pole system. The authors modeled  the rest of the \ac{eoms}, i.e., mass and Coriolis matrix as well as conservative forces, with a classical minimal coordinate approach. The overall model outputs the accelerations which are then integrated in time to obtain the corresponding states.  

Likewise, \cite{2021_DeGroote_TM} employed a recurrent \ac{nn}  trained with  the states (slider position and velocity) and input  torque of a  \ac{2d} slider crank mechanism. The network   predicts the unknown (spring and friction) forces acting on  the slider. The overall hybrid model is then integrated with the explicit Euler scheme to obtain the unknown states of the next time instance.

More restrictive approaches like the aforementioned \cite{2020_Roehrl_IFAC, 2021_DeGroote_TM} try to identify the residual gap between model and reality only, but no NN insight into the full dynamic  behavior is established.

Other approaches are also often tailored to  specific predictions with, again, no insight into the overall system dynamics. For example, \cite{2020_Stoffel_CMAME}  compares modular radial basis function versus convolutional and \ac{ff} topologies for shock tube experiments, where the time-dependent pressure, specimen stiffness, and   shock wave propagation belong to the input data used by the  network to predict   the specimen's mid-point deflection.


More  closely related works \ac{wrt} the current contribution are  those of  \cite{2021_Birky_JLFNVAC}, \cite{2019_Wu_JEM}, and \cite{2021_Choi_MSD}. Akin to our work, the authors  want a network to learn the overall dynamics of a system and predict  time responses of the states.

Birky et al. \cite{2021_Birky_JLFNVAC} analyze a nonlinear structural  finite element model to produce the acceleration time history of both the end and mid-span of a cantilever beam. To this end  data reduction tools  from mathematical morphology are employed so that the acceleration time series  can be converted into a low dimensional representation (referred to as \ac{gsd}) that   describes each acceleration curve. The \ac{nn} is   employed to predict a \ac{gsd} from a new set of physical parameters (such as beam width and thickness, coefficient of friction,  magnitude of pressure loading) and subsequently a nearest neighbor approach is used to determine which predetermined cluster the new \ac{gsd} belongs to and which known acceleration curve  within the cluster it is closest to.


Similar objectives, i.e., predicting the whole time series in one pass of the network, may be found in  \cite{2019_Wu_JEM}   where a deep convolutional \ac{nn}  is used to estimate the dynamic response of a linear single-\ac{dof} oscillator, a nonlinear  damped   duffing oscillator, and a multi-\ac{dof} steel frame.  This study uses   vibration time history signals such as displacement, velocity, acceleration, and excitation,      obtained from either   simulation or experiment as the input of the \ac{nn} to output the whole displacement, acceleration, and/or   restoring force time history.   

The two aforementioned approaches seem unnecessarily complex and expensive considering the current contribution where it is shown that a network can simply predict the states of the next time increment and may be recursively applied to its own prediction to generate time histories.


More aimed for general implementations in hybrid simulation environments is the work of  \cite{2021_Choi_MSD} which generates two types of meta models for the analysis of a slider-crank mechanism,  single and double pendulum, and vibrating transmission system: The first approach generates one  meta model for each time instance, where the \ac{nn}'s  inputs  are geometrical parameters and its outputs the system states. The second approach generates one overall meta model where time is in addition included in the input data and the output is again the  states at this specific time instance of the input stack. Both approaches are somewhat questionable; the former   from a usability point of view and the latter from a mechanical one.


Another school of thought tries to inspire the \ac{nn} strategy by knowledge from  dynamical systems theory, e.g., mimicking the  Koopman operator \cite{1931_Koopman_PNAS,2021_Brunton_ARXIV} with \acp{nn} \cite{2020_Azencot_ARXIV}. The authors of   \cite{2020_Azencot_ARXIV} design an autoencoder  to embed   inputs in a latent space where the dynamics is linear using a nonlinear
map. The decoder map allows to reconstruct latent
variables in the spatial domain. To account for the forward as well as backward dynamics,
two linear layers with no biases, representing the Koopman operator, are    incorporated  into the  
network which is tested on a simple pendulum and a fluid flow application.


Knowledge about symmetries and conservation laws from classical  mechanics can be also leveraged in combination with \acp{nn}. To this end scholars use \acp{nn} to learn the Lagrangian \cite{2020_Cranmer_ARXIV}, Hamiltonian \cite{2019_Greydanus_ARXIV},  energy terms  \cite{2022_NajeraFlores_NSS}, or the mass matrix, potential energy, and non-conservative forces \cite{2019_Gupta_ARXIV}. Applying differentiation rules from analytical dynamics yields the \ac{eoms} that can be integrated in time. 
% Three separate networks are used to learn the energy terms: the potential (U) and kinetic energy (T) terms and the Rayleigh damping (I) are each modeled with a  multilayer perceptron  two DOF damped oscillator with cubic nonlinearities. 

Including physics information, such as the conservation of energy, into \acp{nn} is also advantageous for the objectives of the current paper which will provide an overview of  various design considerations for using \acp{nn} as  time stepping schemes in mechanical system dynamics applications. %\vspace{-0.5cm}

\begin{figure}
	\centering\includegraphics[width=1\linewidth]{figures/prev_steps.pdf}
	\caption{Double pendulum NN trained with and without previous steps}
	\label{fig:prev_steps}
\end{figure}
\section{Implementation}
%overview of the network code, the training approach, the post processing
The NNs developed in this paper are intended to work as a time stepping scheme and therefore they receive a system state vector $\mathbf{s}_t$ and predict the states $\mathbf{s}_{t+1}$ one step in the future. The NNs can then be applied recursively in a closed loop on their own outputs. The advantage of this approach is the unlimited ability to extrapolate in time. Extrapolation in other training domains is also presented in sec. \ref{sec:cases}.
\subsection{Neural Networks and their Training} \label{subsec:rae}
The NNs used here are implemented in \textit{Matlab} with the deep-learning toolbox. The environment was selected for the ease with which custom network layers, cost functions and optimization routines could be implemented. Training and optimization is conducted on a 16-core 4.5GHz machine with 128GB of RAM and 3060 GPU. The focus in this paper is on NNs which can be trained in a matter of minutes, enabling iterative optimization of hyper-parameters. The networks have 3 hidden-layers with 50 nodes per layer on average, with large variations possible.\par

%\begin{figure}
%	\centering\includegraphics[width=1\linewidth]{figures/RAE.pdf}
%	\caption{Visual representation of the Relative Area Error metric}
%	\label{fig:REA}
%\end{figure}
Time series data is always partitioned into a training and validation set with a ratio of 4:1. The time series are  shuffled every epoch to prevent over-fitting. A piecewise learn rate schedule is used to decrease the time required to achieve optimal results during training. The validation loss during training is the deciding factor for identifying optimal networks. The Adams optimizer is used to train the network weights and biases. \par
Throughout the paper, two metrics are used for quality quantification. The Root Mean Square Error (RMSE) is calculated by the square root of the average difference between all the predicted samples $\hat{y}_i$ of a time series compared to the ground truth $y_i$. This metric is also used as the starting point for the NN cost functions discussed in sec. \ref{sec:cost}. When comparing NN performance in the following tables, the RMSE is always calculated using 100 randomly selected time series. The Relative Area Error (RAE) is calculated by dividing the sum of the absolute error area by the absolute ground truth area. The purpose of this metric is to quantify the visual difference seen when comparing plots. It also has the advantage of normalizing the network error, allowing a comparison across different mechanical systems with various sizes and units. It however has the disadvantage of over-rewarding NNs applied to time-series with an offset from zero as seen in fig. \ref{fig:Duffing_saw}.
\begin{equation}
	\text{RMSE}\equiv \frac{1}{N}\sum_{i=1}^{N}(y_i-\hat{y}_i)^2 \quad   \text{RAE}\equiv\frac{\sum_{i=1}^{N}\left| y_i-\hat{y}_i\right|}{\sum_{i=1}^{N}\left|y_i\right|}
\end{equation}
\subsection{Mechanical Systems}
The reference solutions for the mechanical systems are generated using \textit{Matlab Simulink} with the \textit{Simscape Mechanics} library. This enables the simple GUI-based generation of complex systems which can be directly addressed and varied by the NN training code. The mechanical reference simulations have a relatively large time-step of $0.01$ s to match that of the NN. The  fourth-order explicit Runge-Kutta (RK4) solver was selected for its high speed and accuracy. Fast execution is vital due to the need to generate a vast library of time-series, which span the parameter space when training. The accuracy of the simulation was validated by comparison to known analytical solutions for simple systems. \par
Use of significantly smaller step-sizes down to $5 x 10^{-5}$ s was considered, to guarantee accuracy of the chaotic systems. Then to generate the reduced simulation rates discussed in sec. \ref{sec:Training_Domains}, a linear sub-sampling of the full resolution time-series could be conducted. However the duration required to generate the large training sets with so high temporal resolution proved infeasible. It is also unnecessary, as seen in fig. \ref{fig:closed_loop}, where the use of a large step size of 0.01s provides accurate results. Only when using lower order solvers in combination with large step sizes do the peaks of the oscillations no longer match. 

\section{Input Data}
The time-series of training data provided to the NN are the only opportunity the NN has to learn physical dynamics. It is therefore crucial that the data adequately and accurately spans the parameter variation space selected. Beyond spanning the parameter space, it is also a deciding factor how one chooses to traverse the temporal domain. 

\subsection{Training Domains} \label{sec:Training_Domains}
The selection of training step-size for the NN can have a significant influence on its accuracy. Although it could be assumed that reducing the step size would always increase the accuracy by more finely and linearly resolving the dynamics, this is not the case. Because the NN always predicts at the same sampling frequency it was trained with, using fine steps, results in a network which has to take a large number of steps to cover a short time period. The large number of recursive applications of the network upon its own output compound the effect of drift and other errors. This results in an inaccurate NN which takes long to train. Use of very small step sizes, where two consecutive system states are almost identical, may also make it difficult for the network to learn the underlying dynamics as it's almost mapping an identity function. It is therefore recommended to run a quick sensitivity analysis as shown in tab. \ref{tab:freq}. The parameters of the test cases in the paper were tuned such that they could all be trained at 100Hz. For a real system the inverse would be done, where the sampling frequency would be tuned to fit the system.\par
 \begin{table}[t]
 	\caption[Table]{Duffing Oscillator prediction  frequencies}\label{tab:freq}
 	\centering{%
 		\begin{tabular}{lrrr}
 			\toprule
 			Frequency (Hz) & RMSE (m) & RMSE (m/s) \\
 			\midrule
 			50 & 0.4679 & 0.2576 \\
 			\rowcolor[gray]{.95}100 & 0.2422 & 0.1347 \\
 			200 & 0.5141  & 0.3004  \\
 			\bottomrule
 		\end{tabular}
 	}
 \end{table}
Two methods for training using the time series have been explored. In the basic approach, one reference state vector is given to the NN and the next step output error is directly computed. This approach is repeated for all samples of all time series. This approach is simple to implement and fast. However by using potentially slower, closed-loop training, better results can be achieved, as seen in tab. \ref{tab:closed}, where a 53\% reduction in the error is achieved. Closed loop training consists of giving the network only the initial reference state and having the network predict the entire time series recursively using its own outputs. The total predicted time series is then compared to the reference to calculate the error. The closed loop approach helps to prevent NNs from drifting away over time. By over-determining the optimization in this way, the network is better able to capture the physical dynamics, even when using small steps with minimal difference between the individual steps.\par

\begin{figure}
	\centering\includegraphics[width=1\linewidth]{figures/closed_loop.pdf}
	\caption{Double pendulum NN with and without closed-loop training}
	\label{fig:closed_loop}
\end{figure}


  \begin{table}[t]
  	\caption[Table]{Double Pendulum Closed loop training}\label{tab:closed}
  	\centering{%
  		\begin{tabular}{l@{}rrrrr}
  			&  &  RMSE&  & \\
  			\toprule
  			Trained with\\ closed loop & $\theta_1$ (rad) & $\theta_2$ (rad) & $\omega_1$ (rad/s) & $\omega_2$ (rad/s)\\
  			\midrule
  			no   &0.0253 & 0.0327 & 0.0693& 0.1125 \\
  			yes & 0.0101 &  0.0169& 0.0311& 0.0579 \\
  			\bottomrule
  		\end{tabular}
  	}
  \end{table}
\subsection{Derivatives}\label{sec:inte}
Enhancing the state vector with additional time derivatives is one simple to implement approach for using time information. However it also increases the size of the network. Results with this approach are also mediocre. Instead, known temporal relationships between the state steps can be utilized to improve prediction performance. It is known that the position is the integral of the velocity and the velocity the integral of the acceleration. There exist a large number of well established numerical integration schemes for accurately calculating position based on the acceleration. The novel approach proposed here utilizes a proven integration scheme in conjunction with a NN. The NN is only used for what is truly unknown: the EOM which relates the position and velocity to the acceleration. The predicted acceleration is then propagated forwards to the position and velocity of the next time step using a proven numerical integration scheme.\par
Numerous integration schemes have been tested, with the first order Verlet integration scheme providing the best results. It appears to inadvertently compensate the errors made by the network prediction in ways that other schemes don't. The scheme consists of two steps, where first is an explicit-euler equivalent velocity calculation, and the second step is an implicit-euler equivalent position calculation. Together the two steps form the explicit Verlet scheme \cite{1967_Verlet_PR}. 
\begin{equation}
	v_{t+1}=v_t+\Delta t a_{t} \quad\text{and} \quad x_{t+1}=x_t+\Delta t v_{t+1}
\end{equation}




\subsection{Previous States}
The law of causality stipulates that with a full description of the current state of a system, any future state is fully determined. This means that: like a classic integration scheme applied to EOMs, a NN should be able to predict a future state solely based on the current one. However supplying a NN with historical system data has shown to improve its performance in some cases. Tab. \ref{tab:prevsteps2} and fig \ref{fig:prev_steps} show how increasing the number of previous states concatenated to the current state vector reduces the RMSE. However this trend does not continue past 8 steps in this case. One possible explanation is over-fitting on the training data trends. It should be noted that the previous values are all initialized with reference data, thereby giving the advantage of receiving more starting information.

\begin{table}[t]
	\caption[Table]{Duffing Oscillator with Previous steps}\label{tab:prevsteps2}
	\centering{%
		\begin{tabular}{lrrr}
			\toprule
			Previous Steps & RMSE (m) & RMSE (m/s) \\
			\midrule
			reference& 0.5046 & 0.2654 \\
			6 & 0.4096 & 0.2376 \\
			7 & 0.2462 & 0.1531  \\
			\rowcolor[gray]{.95}8 & 0.2422 & 0.1347 \\
			9 & 0.3469 & 0.1874  \\
			10 & 0.4219 & 0.2108  \\
			\bottomrule
		\end{tabular}
	}
\end{table}

\section{NN Architecture}
\subsection{Hyper-parameters}
Hyper-parameters dictate the form the NN will take and how the input states pass through it. The two most important factors are the choice of activation function and size/number of layers. The activation function is the non-linearity applied to a node after the weighted summing and biasing from the previous layer. Matching the activation function to the type of non-linear behaviour expected in the mechanical system itself has proven productive. Size and depth of layers need to be large enough to capture the complexity of the input to output behaviour. But not so abundantly large as to enable over fitting or demand long training periods. The minimal necessary number of NN training parameters should be used in the architecture, so as to only represent the core system dynamics. \par
There is a large number of hyper-parameters available to optimize the training process itself. Clever selection of values for the batch-size, learning-rate drop-factor and learning-rate drop-period can help the training converge towards a minimum faster. However too aggressive selection can also prevent the NN from converging at all. To ensure convergence during optimization, and avoid accidentally skipping over a good NN architecture, conservative estimates are used for the analysis in this paper. This comes at the cost of longer training times.\par\label{sec:auto_tune}
Tuning of the previously discussed hyper-parameters may be attempted manually by hand. However, the complex relationships between the parameters and their effect of the error make this a very difficult task. An automated search through the hyper-parameter space is necessary to reliably find global minima. The simplest approach is a Monte-Carlo sampling of all the hyper-parameters. Although it is not efficient, it gives a good overview of the error terrain. After converging on a global valley, swarm-based or evolutionary optimizers may be employed.
\subsection{Multi-network Structures}
In order to have more targeted control over a NN and it's calculation of individual states, a multi-network structure may be utilized. It consists of a single "root" network which does pre-processing of the input for all the outputs and then passes encoded information onto several "branch" NNs. The individual branches can then have tuned architectures and non-linearities based on their physical output. This enables the targeted insertion of expert knowledge into the network. The individual branches can then be swapped out or trained separately in a modular manner. A qualitative representation of this approach is shown in fig. \ref{fig:GyroNN}.\par
\begin{figure}
	\centering\includegraphics[width=1\linewidth]{figures/Gyro_NN.pdf}
	\caption{Qualitative Representation of Gyroscope NN with the unlabeled blocks containing fully-connected layers of weights and biases}
	\label{fig:GyroNN}
\end{figure}
One possible building block for a multi-network structure is a Long Short-Term Memory (LSTM) layer. LSTM's are an entire hidden structure of weights and biases with internal hidden states and memory. Although originally developed for natural language processing, they have also proven very capable at predicting time series of data \cite{karpathy}. Their design automatically addresses issues associated with training recurrent neural networks without needing manuals tuning by a user.


\section{Cost Function} \label{sec:cost}
A cost function is used to describe how wrong a NN prediction is compared to the ground truth of the training data. The total cost is then propagated back through the NN to determine the effect of each weight and bias on the final outcome errors. The gradient of the cost function w.r.t the NN parameters is used to determine the correction factors for each individual parameter. Correct selection of a cost function is crucial as it is responsible for updating  the NN so that its behavior matches the training data.\par
The most basic implementation of this cost metric $C$ is the root mean squared difference between the $N$ components of the reference state vector $\mathbf{y}$ and the predicted state vector $\hat{\mathbf{y}}$,
\begin{equation}
	C=\frac{1}{N}\sum_{i=1}^{N}(y_i-\hat{y}_i)^2.
\end{equation}
The motivation for using this error metric is its computationally cheap analytical derivation with a smooth and continuous gradient. The flattening of the slope towards the minimum also makes it ideal for gradient descent. However it does not account for the fact that certain combinations of states may not be physically valid with the boundary conditions of the mechanical system being represented. This may result in predictions with a relatively low error but violation of physical principals such as energy or momentum conservation. Expert knowledge which determines the validity of a predicted state vector can be supplemented to the cost function. This results in a training during which the NN is motivated to produce outputs consistent with physical laws. These networks are classified as \textit{Physics Informed Neural Networks (PINNs)}.\par
It is important to note that these physics informed additions to the cost function do not strictly enforce the physical validity of the NN predictions. They do not prevent the NN from having non-physical outputs when used on unseen data. The NN is merely motivated during training to find weights and biases  which tend towards physical results on the training data. Determining future states indirectly through prediction of the Lagrangian would be necessary to strictly ensure energy conservation \cite{2020_Roehrl_IFAC}.
\subsection{Energy Conservation}
\begin{figure}
	\centering\includegraphics[width=1\linewidth]{figures/energy_conservation.pdf}
	\caption{State prediction of double pendulum described in sec. \ref{subsec:pendulum}, with and without energy conservation}
	\label{fig:energy_conservation}
\end{figure}
The energy-based approach seeks to enforce a conservation of the total system energy for every time step between the predicted state and the reference state. With the total mechanical energy $E$ consisting of a sum of the kinetic energy $\mathcal{T}$ and the potential energy $\mathcal{V}$, defined as
\begin{equation}
	\mathcal{T}=\frac{1}{2}\left( m\mathbf{v}_{\text{com}}^2+\boldsymbol\omega^\top\boldsymbol\theta^{\text{com}}\boldsymbol\omega\right)\quad\text{and}\quad   \mathcal{V}=\frac{c}{2}\left( l-l_0\right)^2+mgh
\end{equation}
for an arbitrary example. This means the systems itself does not have to be conservative. It may, for example have a dashpot which reduces the mechanical energy. This is accounted for by calculating the total mechanical energy $E(y_i)$ of the reference state, which contains the effect of the energy reduction, and comparing it to the energy $E(\hat{y}_i)$ of the predicted state:
\begin{equation}
	C_E=\frac{\left|E(y_i)-E(\hat{y}_i)\right|}{E(y_i)+\epsilon}
\end{equation}
where $\epsilon$ is a constant used to prevent the division by $0$ and also to adjust the importance of conserving energy during training. This error in the energy can be added to the cost function in one of two ways. Either the total energy error is added to the end of the cost function
\begin{equation}
	C=\frac{1}{N}\sum_{i=1}^{N}(y_i-\hat{y}_i)^2 +C_E
\end{equation}
or the total energy error is multiplied by the individual output errors. This can be seen as penalizing state errors more if those states have a high energy and therefor a more prominent role in the overall dynamic of the time response.
\begin{equation}
	C=\frac{1}{N}\sum_{i=1}^{N}(y_i-\hat{y}_i)^2 (1+C_E)
\end{equation}
This approach comes with the disadvantage of requiring a deeper a priori understanding of the system and how its total energy can be calculated. It includes the prerequisite of full observability of all states which represent a storage of energy in the system. Additionally, system parameters such as inertia-tensors or spring stiffnesses may also be required. Something which is not necessarily possible when using real-world measurements. \par
As seen in fig. \ref{fig:energy_conservation}, use of an energy term can improve the prediction performance. Whether an addition or multiplication of the energy error is better, has to be evaluated on a case-by-case basis.



\begin{figure}
	\centering\includegraphics[width=1\linewidth]{figures/Pendulum_NN.pdf}
	\caption{Qualitative Representation of Pendulum NN with additional historical states concatenated to the current state vector}
	\label{fig:PendulumNN}
\end{figure}

\subsection{Momentum Conservation}
Following the same approach as for the energy cost function, so too can a momentum $p$ or angular momentum $L$ conserving term be added. These can be calculated as
\begin{equation}
	C_p=\frac{\left|p(y_i)-p(\hat{y}_i)\right|}{p(y_i)+\epsilon_p} \quad\text{and}\quad  C_L=\frac{\left|L^r(y_i)-L^r(\hat{y}_i)\right|}{L^r(y_i)+\epsilon_L}
\end{equation}
with the important note that the result and calculation method for the angular moment depends on the selected reference point $r$. The total cost function then takes the following form:
\begin{equation}
	C=\frac{1}{N}\sum_{i=1}^{N}(y_i-\hat{y}_i)^2 (1+C_E+C_L+C_P)
\end{equation}
As for the energy cost function, here significant a priori system information is also required. However unknown system parameters can be circumvented by only considering conservation in certain directions, or selecting convenient points of reference. 
\section{Case Studies} \label{sec:cases}


\begin{figure*}
	\begin{subfigure}[t]{0.33\textwidth} % subfigure is basically the same as minipage
		%\vbox{
			%\vspace*{1.7em}
			\centering{
			\import{figures}{Pendulum_example.pdf_tex}
			}%
			%\vspace*{1.7em}
		%}%
		\subcaption{Double pendulum\label{fig:example_pendulum}}
	\end{subfigure}
	\begin{subfigure}[t]{0.33\textwidth}
		\hspace{0.5cm}
		\vbox{
		\centering{%
			\import{figures}{Duffing_example.pdf_tex}
		}%
		}
		\subcaption{Duffing oscillator \label{fig:example_duffing}}
	\end{subfigure}
	\begin{subfigure}[t]{0.33\textwidth}
		\centering{%
			\import{figures}{Gyro_example_small.pdf_tex}
		}%
		\subcaption{3D Gyroscope\label{fig:example_gyro}}
	\end{subfigure}
	\caption{The 3 mechanical case studies}
\end{figure*}

Three different mechanical systems are used to demonstrate the variety of approaches required to achieve optimal results. The double pendulum in fig. \ref{fig:example_pendulum} is a chaotic system which is solved using an energy-conserving cost approach with 8 historical states as inputs. NN robustness against training noise is demonstrated on this testcase. The duffing oscillator in fig. \ref{fig:example_duffing} is a non-linear vibration system with a variable external excitation. It is solved using an LSTM+integration NN and used to demonstrate the ability to extrapolate. The gyroscope in fig. \ref{fig:example_gyro} is a 3D system with complex rotational behaviour. A branched NN is used to demonstrate the ability to determine system-parameter dependent solutions.


\begin{table}[h]
	\caption[Table]{Double Pendulum trained with energy cost}\label{tab:energy}
	\centering{%
		\begin{tabular}{l@{}rrrrr}
			&  &  RMSE&  & \\
			\toprule
			Trained with\\ energy cost & $\theta_1$ (rad) & $\theta_2$ (rad) & $\omega_1$ (rad/s) & $\omega_2$ (rad/s)\\
			\midrule
			no   &0.0331 & 0.0487 & 0.0989& 0.1649 \\
			yes & 0.0074 &  0.0120& 0.0232& 0.0420 \\
			\bottomrule
		\end{tabular}
	}
\end{table}

\begin{table}[h]
	\caption[Table]{Double Pendulum trained with noise}\label{tab:noise}
	\centering{%
		\begin{tabular}{l@{}rrrrr}
			&  &  RMSE&  & \\
			\toprule
			Noise  & $\theta_1$ (rad) & $\theta_2$ (rad) & $\omega_1$ (rad/s) & $\omega_2$ (rad/s)&  REI\\
			\midrule
			reference & 0.0074 &  0.0120& 0.0232& 0.0420 &\\
			1\%       & 0.0119 & 0.0130 & 0.0272& 0.0449 &1.2\\
			2\%       &0.0133  & 0.0132 &0.0277 & 0.0402 &1.3\\
			5\%       & 0.0506 &  0.0343&0.0783 &  0.0800&3.7\\
			10\%       & 0.1119 & 0.1047 &0.2353 & 0.3054 &10.3\\
			\bottomrule
		\end{tabular}
	}
\end{table}
\subsection{Double Pendulum} \label{subsec:pendulum} 
The double pendulum is a chaotic system with highly variable dynamics for different initial conditions. In this test case the  state vector consists of the two relative angles $\theta_1$ and $\theta_2$ along with the two respective angular velocities $\omega_1$ and $\omega_2$. The initial angles are varied in the ranges $[0,24]$ respectively $[-30,30]$ while the initial angular velocities are always 0. The optimal network uses an energy based cost function with 8 previous steps appended to the input vector, to directly predict the next system state vector. Sixty 5s time-series are split 4:1 into training and validation datasets. Larger datasets are not used, as the focus is on fast hyper-parameter optimization and training. However,  use of more data often helps, up to a point of saturation. Tab. \ref{tab:energy} demonstrates how use of the energy information during training reduces the average RMSE by a factor of 0.55.\par
If the intention of the NNs is to apply them to real-world data, robustness against noisy training data is paramount. Tab. \ref{tab:noise} shows that the double pendulum NN is still able to produce reasonable results despite noise. Nonetheless, NNs trained on data with increasing levels of noise deteriorate in quality. This prediction quality decline is quantified using the Relative Error Increase (REI) compared to the reference NN with no noise. The noise applied to the training data is meant to replicate broad band sensor noise. Therefore, uncorrelated white noise with a maximal amplitude set to a fixed percentage of the maximal signal amplitude was used. It can be seen that 10\% noise causes the RMSE to increase by an order of magnitude on average. The recommended solution is to employ classical signal filtering techniques to remove the noise before training. The risk being that important mechanical vibrations also get cut off because it may be unknown how high-frequent the system dynamics are. Systematic or correlated signal issues can also not be removed. 




\begin{figure}
	\centering\includegraphics[width=1\linewidth]{figures/Pendulum_noise.pdf}
	\caption{Effect of training data noise on Pendulum NN}
	\label{fig:1}
\end{figure}

\subsection{Duffing Oscillator} \label{subsec:duffing}
The duffing oscillator described by \ref{eq:duff} is a vibrating system with multiple stable configurations. The non-linear spring element $\beta$ introduces an amplitude dependence resulting in a shifting eigen-frequency. Addition of an external force of variable amplitude $\gamma \in [0.1,0.5]$ and frequency $\omega \in [0.4-1.5]$ rad/s excites the non-linearity in different ways. The damping term $\delta$ dissipates energy from the system. This element represents a typical building block of structural multi-body simulations.\par
\begin{figure}
	
	\centering\includegraphics[width=1\linewidth]{figures/Duffing_NN.pdf}
	\caption{Qualitative of duffing NN used to predict acceleration}
	\label{fig:duffNN}
\end{figure}

\begin{equation}
	\ddot{x}+\delta \dot{x}+\alpha x + \beta x^3=\gamma \cos(\omega t)
	\label{eq:duff}
\end{equation}
Due to the complexity of the EOM, the numerical integration scheme discussed in sec. \ref{sec:inte} is used, letting the NN focus on only predicting the acceleration $\ddot{x}$ based on the input state $x$ and velocity $\dot{x}$. To further aid with the prediction an LSTM layer is also used. This system exemplifies how there isn't a single catch-all solution, as in this case use of an energy-conserving cost function would only appear to decrease performance.\par
A simulation duration of $50$ s is used for the duffing oscillator so that the transient at the start as well as a few oscillations of the steady state response are included in the training data. Interestingly, some trained NNs repeatedly exhibit behaviour shown in fig. \ref{fig:Duffing_bad}. The NN appears to be able to accurately represent the initial transient and the steady-state response at the end, but has difficulty with the transition between the two phases. This indicates that the NNs solve these two phases independently and have difficulty in the shifting from one to the other. However this effect can be completely removed by optimal selection of the hyper-parameters as discussed in sec. \ref{sec:auto_tune}.\par
\begin{figure}
		\vspace{-0.2cm}
	\centering\includegraphics[width=1\linewidth]{figures/Duffing_bad.pdf}
	\caption{Example of NN having difficulty predicting the transition between the transient- and steady-state-phase}
	\label{fig:Duffing_bad}
	\vspace{-0.8cm}
\end{figure}
Although NNs are often inaccurate at extrapolating beyond the range of the training data \cite{extrapolation}, with optimal design of the architecture, accurate extrapolation can be achieved. Upon training of a NN on excitations with a frequency $\omega \in [0.4, 1.5]$ and amplitude $\gamma \in [0.1, 0.5]$, the NN is able to accurately predict dynamics below and above these ranges. Excitation frequencies from $0\%$ up to $400\%$ of the training range can be predicted, as well as $0\%$ up to $150\%$ of the amplitude range, as shown in fig. \ref{fig:Duffing_extrapolation}. The extrapolation performance is not as good for the amplitude, because the cubic spring introduces a significant amplitude dependence. The form of this amplitude dependence is not known to the NN beyond the range of the data it was trained with. Extrapolation in time is also possible with the NN in fig. \ref{fig:Duffing_extrapolation} only being trained on $20$ s of data, but easily predicting to $50$ s. A summary of the individual extrapolation performances is summarized for various validation datasets in tab. \ref{tab:extra}. Only parameters below and above the training range are included in the validation, the range of the training set is excluded. The RMSE for $\omega$ extrapolation is lower than that of the reference because the overall motion amplitude of the system decreases for high frequencies. Use of the RAE metric from sec. \ref{subsec:rae} would be better suited to represent the relative differences.\par
\begin{table}[t]
	\caption[Table]{Duffing Oscillator Extrapolation}\label{tab:extra}
	\centering{%
		\begin{tabular}{lrrr}
			\toprule
			  & Extrapolation & RMSE (m) & RMSE (m/s) \\
			\midrule
			reference & - & 0.1686& 0.1101 \\
			$\omega$ & $0$ - $400\%$ & 0.0726   & 0.0651  \\
			$\gamma$ & $0$ - $150\%$ & 0.4352   & 0.3908 \\
			time duration & $500\%$ & 0.1962   & 0.1139 \\
			\# of excitations & 2 & 0.2415   & 0.1068 \\
			\bottomrule
		\end{tabular}
	}
\end{table}
Despite only being trained on single harmonics (SH), the NN is also able to predict the response of the system to double harmonics as seen in in fig. \ref{fig:Duffing_double_harmonics}. This performance can however be enhanced by directly training on excitation signals which contain double harmonics (DH). The significance of these findings is the notion that it is sufficient to train a NN with single harmonics in a limited range, and it will be able to generate the response to an arbitrary non-harmonic non-continuous excitation as seen in fig. \ref{fig:Duffing_saw}. Here a non-continuous sawtooth excitation force is applied to a NN only trained on sinusoidal time series. The NN is able to predict the response to the sharp edges which excite all structural frequencies with astounding accuracy.



\begin{figure*}
	\begin{subfigure}[t]{0.5\textwidth}
		\hspace{0.5cm}
		\vbox{
			\centering{%
	\centering\includegraphics[width=0.9\linewidth]{figures/Duffing_extrapolation_freq.pdf}
			}%
		}
		\subcaption{Extrapolation of excitation frequency \label{fig:Duffing_extrapolation_freq}}
	\end{subfigure}
	\begin{subfigure}[t]{0.5\textwidth}
		\centering{%
	\centering\includegraphics[width=0.9\linewidth]{figures/Duffing_extrapolation_amp.pdf}
		}%
		\subcaption{Extrapolation of excitation amplitude \label{fig:Duffing_extrapolation_amp}}
	\end{subfigure}
	\caption{Duffing oscillator trained on $20$ \NoCaseChange{s} of data, extrapolating with unseen excitation force to $50$ \NoCaseChange{s}}\label{fig:Duffing_extrapolation}
\end{figure*}

\begin{figure*}
	\begin{subfigure}[t]{0.5\textwidth}
		\hspace{0.5cm}
		\vbox{
			\centering{%
				\centering\includegraphics[width=0.9\linewidth]{figures/Duffing_double_harmonics.pdf}
			}%
		}
		\subcaption{Prediction performance on double harmonics \label{fig:Duffing_double_harmonics}}
	\end{subfigure}
	\begin{subfigure}[t]{0.5\textwidth}
		\centering{%
			\centering\includegraphics[width=0.9\linewidth]{figures/Duffing_saw.pdf}
		}%
		\subcaption{Prediction performance on sawtooth profile \label{fig:Duffing_saw}}
	\end{subfigure}
	\caption{Duffing oscillator NN predicting various force signals.}\label{fig:Duffing_excite}
\end{figure*}
\subsection{Gyroscope}

\begin{figure*}
	\vspace{-0.5cm}
	\begin{subfigure}[t]{0.5\textwidth}
		\hspace{0.5cm}
		\vbox{
			\centering{%
				\centering\includegraphics[width=0.9\linewidth]{figures/Gyro_noIvar.pdf}
			}%
		}
		\subcaption{Variation of initial conditions only \label{fig:Gyro_noivar}}
	\end{subfigure}
	\begin{subfigure}[t]{0.5\textwidth}
		\centering{%
			\centering\includegraphics[width=0.9\linewidth]{figures/Gyro_Ivar.pdf}
		}%
		\subcaption{Variation of initial conditions and inertia \label{fig:Gyro_ivar}}
	\end{subfigure}
	\caption{Gyroscope NN predicting States with various inputs}\label{fig:Gyro}\vspace{-0.6cm}
\end{figure*}
Another mechanical system of interest is the three dimensional gyroscope. Its state vector consists of a Kardan-angle description of the orientation as well as the angular velocity in the body frame. The dynamical description for the angular velocity is simple in the body frame of reference but the relationship between the body’s orientation in space and the angular velocity becomes more convoluted. Thus, the behavior of a gyroscope is a challenge to predict with a NN.\par
Based on the observed patterns in the behavior of the gyroscope, a branched NN structure is the optimal solution for the problem. This allows each entry of the state vector to be advanced in time by a specialized NN. For example: states which exhibit sinusoidal gyrating motion use a trignometric activation function, whereas more linear states use a ReLu as seen in fig. \ref{fig:GyroNN}. The initial angular velocity of the gyroscope is varied in the two directions $w_{y0} \in [1,1.5]$ and $w_{z0} \in [5,7]$. Additionally, a mechanical property of the system is also varied to demonstrate the NN's deeper understanding of the physical dynamics. Fig \ref{fig:Gyro} shows the network accurately predicting the motion for random initial conditions and random rotational inertia $I_z\in [2,4]$.
 
 
 \begin{table}[t]
 	\caption[Table]{Gyroscope prediction   }\label{tab:prevsteps}
 	\centering{%
 		\begin{tabular}{l@{\hspace{-1cm}}rrr}
 			\toprule
 			 & $q_{1,2,3}$ avgRMSE (rad) & $\omega_{1,2,3}$ avgRMSE (rad/s) \\
 			\midrule
 			Reference & 0.0154 & 0.0498 \\
 			With inertia variation & 0.0142  & 0.0902  \\
 			\bottomrule
 		\end{tabular}
 	}
 \end{table}
 





%%%%% Conclusions %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



\section{Conclusion}

In this work we presented  numerous design parameters and choices available when creating a NN and discussed their effects on the accuracy of predicting dynamics of non-linear mechanical systems. The findings were presented with the support of three test cases: a double pendulum, a duffing oscillator and a  gyroscope. Factors such as the initial conditions, the external forcing as well as system parameters were varied to demonstrate the robustness of the proposed approaches. Furthermore, practical design considerations such as noise-sensitivity as well as the ability to extrapolate were examined. \par
Ultimately, we were able to show that NNs are capable of functioning as time-stepping schemes for complex non-linear mechanical system dynamics applications. However, appropriate design parameters have to be chosen specifically for each system to properly represent the dynamics of the underlying physics. Further research needs to be done to analyse the transferability of these findings to real-world measurements and large scale systems.\vspace{-0.2cm}
%%%%% Acknowledgments %%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%  REFERENCES  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
\nocite{*}
\bibliographystyle{asmeconf} 
\bibliography{asmeconf-sample}%% 
%%%  APPENDICES  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\appendix


\end{document}

